<?php
	/****************************************************************
	*@file gui.php
	*@package FFPROBE
	*@name Gui for ffprobe
	*@author Actarus
	*@version V2.0
	*@note 
	*	V3.0 (26.02.2011) Manu bugs fixed, now PHP4FFProbe has its own section ;)
	*	V2.0 (25.02.2011) Phpize with GUI_info()  gogo!
	*	V1.0 (24.02.2011) Working release
	******************************************************************/
	
	define("FFPROBE_GUI_API","3.0");
	
	function GUI_getHTMLheader() {
	//----------------------------	
		$header='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
		<html>
			<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
				<title>PHP4FFProbe '.FFPROBE_VERSION.'</title>
				<link href="css/styles.css" rel="stylesheet" type="text/css">
			</head>
			<body>';
		echo $header;

	}

	//table's template for fixed things
	$GUI_info=array(
		"header"=>'<table border="0" cellpadding="3" width="600">',
		"headervalue"=>'<tr class="h"><th>Variables</th><th>Value</th></tr>',
		"footer"=>'</table><br />'
	);
	
	function GUI_info_list_getheader() {
	//---------------------------------
		global $GUI_info;
		return $GUI_info["header"];
	}
	
	function GUI_info_list_addheader(&$extsinfo) {
	//--------------------------------------------
		$header=GUI_info_list_getheader();
		$extsinfo[]=$header;
	}
	
	function GUI_info_list_additem(&$extsinfo,$name,$value) {
	//-------------------------------------------------------
		if(is_array($value)) {
			GUI_info_list_addvalues($extsinfo,$name,$value);
		}else {
			GUI_info_list_addvalue($extsinfo,$name,$value);
		}
	}
	
	function GUI_info_list_appenditem(&$extsinfo,$name,$value) {
	//-------------------------------------------------------
		$last_item=array_pop($extsinfo);  //remove footer to append a new item
		GUI_info_list_additem($extsinfo,$name,$value);
		$extsinfo[]=$last_item;
	}
	
	
	function GUI_info_list_addheadercols(&$extsinfo,$keys) {
	//-------------------------------------------------------------
		$extsinfo[]='<tr class="h"><th>'.implode('</th><th>',$keys).'</th></tr>';
	}
	
	function GUI_info_list_addvalues(&$extsinfo,$name,$values) {
	//---------------------------------------------------------
		$extsinfo[]='<tr><td class="e">'.$name.'</td><td class="v">'.implode('</td><td class="v">',$values).'</td></tr>';
	}

	
	//Variable args:  $name,$value or $value
	function GUI_info_list_addvalue(&$extsinfo) {
	//--------------------------------------------
		$args=func_get_args();
		$item_value='';
		if(count($args)>2) {
			$name=$args[1];
			$value=$args[2];
			if($name) $item_value='<td class="e">'.$name.'</td>';
		}else if(count($args)==2) $value=$args[1];
			
		$item_value.='<td class="v">'.$value.'</td>';
		$extsinfo[]='<tr>'.$item_value.'</tr>';
	}
	
	function GUI_info_list_getheadervalue() {
	//---------------------------------
		global $GUI_info;
		return $GUI_info["headervalue"];
	}
	
	function GUI_info_list_addheadervalue(&$extsinfo) {
	//--------------------------------------------
		$footer=GUI_info_list_getheadervalue();
		$extsinfo[]=$footer.PHP_EOL;
	}
	
	
	function GUI_info_list_getfooter() {
	//---------------------------------
		global $GUI_info;
		return $GUI_info["footer"];
	}
	
	function GUI_info_list_addfooter(&$extsinfo) {
	//--------------------------------------------
		$footer=GUI_info_list_getfooter();
		$extsinfo[]=$footer;
	}
	
	function GUI_info_list_renderer(&$extsinfo,$category,$props,$sep=', ') {
	//----------------------------------------------------------------------
		$name=$category;
		$value=implode($sep, $props);
		GUI_info_list_addheader($extsinfo);
		GUI_info_list_additem($extsinfo,$name,$value);
		GUI_info_list_addfooter($extsinfo);
	}
	
	
	function GUI_info_table_renderer($rows) {
	//-------------------------------------
		$table=array('<div style="display:table;width:100%;" class="table">');
		$t='h';
		foreach($rows as $row) {
			
			$table[]='<div style="display:table-row;" class="'.$t.'">';
			if($t=="r") $t='d';
			foreach($row as $cell) {
				$table[]='<div style="display:table-cell;text-align:center;border:#9999cc solid 2px" class="'.$t.'">'.$cell.'</div>';
			}
			$table[]="</div>";
			$t='r';
		}
		$table[]="</div>";
		return $table;
	}
	
	
	function GUI_info_renderer(&$extsinfo,$category,$category_section,$subcategory,$props) {
	//---------------------------------------------------------------------------------------
		$handled=true;
		
		if($category=='formats') {
			switch($category_section) {
				case 'File formats':
					GUI_info_list_addheader($extsinfo);
					
					$keys=array("Name"=>"N","Decoding"=>"D","Encoding"=>"E","Description"=>"F");
					$keys=array_keys($keys);
					
					GUI_info_list_addheadercols($extsinfo,$keys);
					
					//clear the Help
					if(array_key_exists("D.",$props)) unset($props["D."]);
					if(array_key_exists(".E",$props)) unset($props[".E"]);
					
					foreach ($props as $prop_name => $prop_value) {
						GUI_info_list_additem($extsinfo,$prop_name,$prop_value);
					}
					
					GUI_info_list_addfooter($extsinfo);
				break;
				case'Codecs': 
					$keys=array("Name"=>"N","Decoding"=>"D","Encoding"=>"E","Type"=>"T","Slice"=>"S","Direct"=>"R","Truncated"=>"T","Codec"=>"C");
								
					$keys=array_keys($keys);
					
					$prop_types=array("audio"=>"A","video"=>"V","subtitle"=>"S");
				
					foreach($prop_types as $prop_type_name => $prop_type_value) {
					
						$codecs=$props;
						
						//Get the (video|audio|subtitle) codec list
						$codecs=array_filter($codecs,create_function(
							'$codec_value',
							'return ($codec_value[2]=="'.$prop_type_value.'");'
						));
						
						if(count($codecs)>0) {
						
							$extsinfo[]='<a name="'.$prop_type_name.'_codecs"><h3 title="'.count($codecs).' codecs">'.$prop_type_name.'</h3></a>'.PHP_EOL;
						
							GUI_info_list_addheader($extsinfo);
							
							GUI_info_list_addheadercols($extsinfo,$keys);
							
							foreach ($codecs as $codec_name => $codec_value) {
								GUI_info_list_additem($extsinfo,$codec_name,$codec_value);
							}
							
							GUI_info_list_addfooter($extsinfo);
							
						}else{
							die("No $prop_type_name codec!");
						}
					}
				break;
				case 'Bitstream filters':
					GUI_info_list_renderer($extsinfo,"filters",$props["filter"]);
				break;
				case 'Supported file protocols':
					GUI_info_list_renderer($extsinfo,"protocols",$props["protos"]);
				break;
				case 'Frame size and frame rate abbreviations':
					GUI_info_list_renderer($extsinfo,"abbreviations",$props["abbrevs"]);
				break;
				case "Notes":
					GUI_info_list_renderer($extsinfo,"",$props,' ');
				break;
				default:
					$handled=false;
			}
		} else { //Shows
		
			switch($category_section) {
				case 'FRAME':
				case 'PACKET':
					GUI_info_list_addheader($extsinfo);
					
					$frames=$props;
					//if(array_key_exists(0,$frames)) {
					$keys=$frames[0];
					$keys=array_keys($keys);
					
					//shortens the columns names
					$keys = array_map(create_function(
						'$key',
						'return str_replace("_","<br>",$key);'
					), $keys);
					
					
					GUI_info_list_addheadercols($extsinfo,$keys);
					
					foreach($frames as $frame_number=>$frame) {
						$frame_values=array_values($frame);
						$frame_number_ffprobe=array_shift($frame_values);
						GUI_info_list_additem($extsinfo,$frame_number_ffprobe,$frame_values);
					}
					
					GUI_info_list_addfooter($extsinfo);
				break;
				case 'DECODER':
				case 'STREAM':
					$safety=5;
					//this is ugly I know but it works on all cases...
					while(($safety>0)&&(!array_key_exists("codec_type",$props))) {
						$props=array_shift($props);
						$safety--;
					}
					if($safety==0) {
						echo("<br>cannot extract decoder section data from this:");
						echo "<pre>";
						var_dump($props);
						die("</pre>");
					}
					
					GUI_info_list_addheader($extsinfo);
					GUI_info_list_addheadervalue($extsinfo);
					foreach ($props as $prop_name => $prop_value) {
						GUI_info_list_addvalue($extsinfo,$prop_name,$prop_value);
					}
					GUI_info_list_addfooter($extsinfo);
				break;
				case 'FILE':
				case 'TAGS':
					GUI_info_list_addheader($extsinfo);
					GUI_info_list_addheadervalue($extsinfo);
					foreach ($props as $prop_name => $prop_value) {
						GUI_info_list_addvalue($extsinfo,$prop_name,$prop_value);
					}
					GUI_info_list_addfooter($extsinfo);
				break;
				default:
				$handled=false;
			}
		}
		
		if(!$handled) { //Failsafe
			echo("<br>WARNING: GUI_info_renderer uses a failsafe rendering for the section '$category_section' of the category '$category', rendering may not be adequate.");
			GUI_info_list_addheader($extsinfo);
			GUI_info_list_addheadervalue($extsinfo);
			foreach ($props as $prop_name => $prop_value) {
				GUI_info_list_addvalue($extsinfo,$prop_name,$prop_value);
			}
			GUI_info_list_addfooter($extsinfo);
		}
	}
	
	
	function GUI_info($title,$category,$exts) {
	//---------------------------------------

		global $FFprobe_graphs,$GNUPLOT;

		$exts_names=array_keys($exts);

		$style="<style type=\"text/css\">
		.phpinfodisplay {background-color: #ffffff; color: #000000;}
		.phpinfodisplay ,.phpinfodisplay  td,.phpinfodisplay  th,.phpinfodisplay  h1,.phpinfodisplay  h2 {font-family: sans-serif;}
		.phpinfodisplay pre {margin: 0px; font-family: monospace;}
		.phpinfodisplay a:link {color: #000099; text-decoration: none; background-color: #ffffff;}
		.phpinfodisplay a:hover {text-decoration: underline;}
		.phpinfodisplay table,.table {border-collapse: collapse; }
		.phpinfodisplay .center {text-align: center;}
		.phpinfodisplay .center table { margin-left: auto; margin-right: auto; text-align: left;}
		.phpinfodisplay .center th { text-align: center !important; }
		.phpinfodisplay td, .td, .phpinfodisplay  th { border: 1px solid #000000; font-size: 75%; vertical-align: baseline;}
		.phpinfodisplay h1 {font-size: 150%;}
		.phpinfodisplay h2 {font-size: 125%;}
		.phpinfodisplay .p {text-align: left;}
		.phpinfodisplay .e {background-color: #ccccff; font-weight: bold; color: #000000;}
		.phpinfodisplay .h {background-color: #9999cc; font-weight: bold; color: #000000;}
		.phpinfodisplay .v {background-color: #cccccc; color: #000000;}
		.phpinfodisplay .vr {background-color: #cccccc; text-align: right; color: #000000;}
		.phpinfodisplay img {float: right; border: 0px;}
		.phpinfodisplay hr {width: 600px; background-color: #cccccc; border: 0px; height: 1px; color: #000000;}</style>
		";
		
		//HR
		$hr = '<div style="width:600px; background:#000; height:1px;margin-bottom:1em;"></div>';
		
		//FFprobe header
		$header=array();
		GUI_info_list_addheader($header);
		$header[]='<tr class="h"><td><h1 class="p">'.$title.'</h1></td></tr>';
		GUI_info_list_addfooter($header);
		
		
		//FFprobe info
		$ffprobe=FFPROBE_inspect();
		$info=array();
		GUI_info_list_addheader($info);
		GUI_info_list_additem($info,"System","<a href=\"http://falun.dafa.is.free.fr/altair/cosmos/\" style=\"text-decoration: none;\">Altair's cosmos</a>");
		GUI_info_list_additem($info,"Build Date",$ffprobe["date"]);
		if($ffprobe["built"]) GUI_info_list_additem($info,"Build tool",$ffprobe["built"]);
		GUI_info_list_additem($info,"FFprobe directory",FFPROBE_DIR);
		if(file_exists($GNUPLOT)) GUI_info_list_additem($info,"PGnuPlot path",$GNUPLOT);
		GUI_info_list_additem($info,"Formats file",FFPROBE_FORMATS_FILE);
		GUI_info_list_additem($info,"Formats data file",FFPROBE_FORMATS_DATA_FILE);
		GUI_info_list_additem($info,"Formats data sections",FFPROBE_FORMATS_DATA_SECTIONS);
		GUI_info_list_additem($info,"Registered shows",FFPROBE_SHOWS);
		GUI_info_list_additem($info,"Registered show sections",FFPROBE_SHOWS_SECTIONS);
		GUI_info_list_additem($info,"Registered codec types",FFPROBE_CODEC_TYPES);
		GUI_info_list_additem($info,"Author",FFPROBE_AUTHOR);
		GUI_info_list_additem($info,"Realease date",FFPROBE_DATE);
		GUI_info_list_additem($info,"Core API",FFPROBE_VERSION);
		GUI_info_list_additem($info,"Gui API",FFPROBE_GUI_API);
		GUI_info_list_additem($info,"Graph API",FFPROBE_GRAPH_API);
		GUI_info_list_additem($info,"Thanks to",FFPROBE_GREETINGS);
		GUI_info_list_addfooter($info);
		
		//Now, it's the fun part
		$copy=array();
		
		
	
		$license=array(
			"This program makes use of ",
			$ffprobe["version"],
			'Copyright '.$ffprobe["copyright"],
			", based on FFmpeg's engine both LGPL.",
			"   Feel free to use PHP4FFprobe without license nightmare issues as it follows the GPL's stream as well, enjoy!"
		);
		GUI_info_list_addheader($copy);
		GUI_info_list_addvalue($copy,implode(" ",$license));
		GUI_info_list_addfooter($copy);
		
		
		//Overview info
		$overview=array(
			'<h2>Overview</h2>'
		);

		GUI_info_list_renderer($overview,$category,$exts_names);
		
		
		if($category=='formats') {
		
			//Formats overview table 
			$decoding_formats=FFPROBE_count_decoding_formats();
			$encoding_formats=FFPROBE_count_encoding_formats();
			$formats_view=array( 
				array("decoding","encoding"),
				array($decoding_formats,$encoding_formats)
			);
			$formats=GUI_info_table_renderer($formats_view);
			$total_formats=FFPROBE_count_formats();
			GUI_info_list_appenditem($overview,'<a title="'.$total_formats.' in total">file formats</a>',implode(PHP_EOL,$formats));
		
			//graphs plugins
			if(file_exists($GNUPLOT)) {
				$plugins_count=count($FFprobe_graphs);
				if($plugins_count) {
					$plugins_view=array( 
						array("type","version","date","authors")
					);
					foreach($FFprobe_graphs as $plugin_type=>$plugin) {
						$plugin_view=array($plugin_type);
						$plugin_view[]=$plugin->get_version();
						$plugin_view[]=$plugin->get_date();
						$plugin_view[]=$plugin->get_author();
						$plugins_view[]=$plugin_view;
					}
					$plugins=GUI_info_table_renderer($plugins_view);
					GUI_info_list_appenditem($overview,'<a title="'.$plugins_count.' in total">graph plugins</a>',implode(PHP_EOL,$plugins));
				}
			}
			
			//Codecs overview table 
			$codec_types=explode(",",FFPROBE_CODEC_TYPES);
			$codec_processings=explode(",",str_replace(",<>,",',',FFPROBE_CODEC_PROCESSING));
			$codecs_view=array(array_merge(array('type','total'),$codec_processings));
			
			$total_codecs=0;
			foreach($codec_types as $codec_type) {
				$codec_type_count=FFPROBE_count_codecs($codec_type,$exts);
				$codec_view=array(
					$codec_type,
					$codec_type_count
				);
				foreach($codec_processings as $codec_processing) {
					$codec_view[]=count(FFPROBE_codecs_for_processing($codec_type,$codec_processing,$exts));
				}
				$codecs_view[]=$codec_view;
				$total_codecs=$codec_type_count;
			}
		
			$codecs=GUI_info_table_renderer($codecs_view);
			
			if($total_codecs>0) {
				GUI_info_list_appenditem($overview,'<br><a title="'.$total_codecs.' in total">codecs</a>',implode(PHP_EOL,$codecs));
			}
			
			//modules overview table 
			$modules=$ffprobe["modules"];
			foreach($modules as $module_type => $module) {
				$module_plugins_names=array_keys($module);
				$module_plugins_versions=array_values($module);
				$module_plugins=GUI_info_table_renderer(array($module_plugins_names,$module_plugins_versions));
				GUI_info_list_appenditem($overview,"<br>$module_type module",implode(PHP_EOL,$module_plugins));
			}
			
		}
		
		if($category=='shows') {
			$frames_video_count=FFPROBE_count_frames("video",$exts);
			$has_video=($frames_video_count>0); 
			GUI_info_list_appenditem($overview,"video",($has_video)?"yes":"no"); 
			if($has_video) {
				GUI_info_list_appenditem($overview,"Total video frames",$frames_video_count); 
				GUI_info_list_appenditem($overview,"Total video keyframes",FFPROBE_count_keyframes("video",$exts)); 
			}
			
			$frames_audio_count=FFPROBE_count_frames("audio",$exts);
			$has_audio=($frames_audio_count>0);
			GUI_info_list_appenditem($overview,"audio",($has_audio)?"yes":"no"); 
			if($has_audio) {
				GUI_info_list_appenditem($overview,"Total audio frames",$frames_audio_count); 
				GUI_info_list_appenditem($overview,"Total audio keyframes",FFPROBE_count_keyframes("audio",$exts)); 
			}
		}
	
		
		$extsinfo=array(
			'<h1>Configuration</h1>'
		);
		
		$category_number=0;
		
		foreach ($exts as $ext => $funcs) {
		
			$extsinfo[]='<h2>'.$ext.'</h2>';
	
			foreach ($funcs as $func_name => $func_value) {
			
				if(is_string($func_name)) {
					
					if(is_string($func_value)) {
						//echo("<br>Func has a string value($func_value)");
						GUI_info_list_addheader($extsinfo);
						GUI_info_list_addheadervalue($extsinfo);
						GUI_info_list_additem($extsinfo,$func_name,$func_value);
						GUI_info_list_addfooter($extsinfo);
					}else {
						$extsinfo[]='<h3>'.$func_name.'</h3>';
					}
				}
				if(is_array($func_value)) {
					//echo("<br>Func has an array value");
					$props=$func_value;
					$subcategory=$func_name;
					
					if($category=="shows") {
						$FFPROBE_SHOWS_SECTIONS=explode(",",FFPROBE_SHOWS_SECTIONS);
						$category_section=$FFPROBE_SHOWS_SECTIONS[$category_number];
					} else if($category=="formats") {
						$FFPROBE_FORMATS_SECTIONS=explode(",",FFPROBE_FORMATS_DATA_SECTIONS);
						$category_section=$FFPROBE_FORMATS_SECTIONS[$category_number];
					}else {
						$category_section=$category_number;
					}
					
					//echo("<br>GUI_info_renderer(category=$category,category_section=$category_section($category_number),subcategory=$subcategory)");
					GUI_info_renderer($extsinfo,$category,$category_section,$subcategory,$props);
						 
				}
			}
			$category_number++;
		}
		
		
		$canvas=array(
			$style,
			'<div class="phpinfodisplay">',
			'<div align="center">',
			implode(PHP_EOL,$header),
			'</div>',
			'<div align="center">',
			implode(PHP_EOL,$info),
			'</div>',
			'<div align="center">',
			implode(PHP_EOL,$copy),
			'</div>',
			'<div align="center">',
			implode(PHP_EOL,$overview),
			"</div>",
			'<div align="center">',
			$hr,
			"</div>",
			'<div align="center">',
			implode(PHP_EOL,$extsinfo),
			"</div>",
			"</div>"
		);
		
		//echo(htmlentities(print_r($canvas,true)));
		
		//OUTPUT
		echo  implode(PHP_EOL,$canvas);
	}
	
	
	function GUI_getHTMLfooter() {
	//-----------------------------
		echo "\t</body>\n</html>";
	}
	
?>